//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www.kamami.com
// PROJECT  : 7SEGMENT
// BOARD    : ZL3ST7 (with ST7FLITE39F2B6 in socket U1)
// COMPILER : RKitSTM8 for Ride7
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple 7-segment LED display demonstration.
//
//    Settings and connections on ZL3ST7:
//        A (7SEG/con14) - PA0 (con15)
//        B (7SEG/con14) - PA1 (con15)
//        C (7SEG/con14) - PA2 (con15)
//        D (7SEG/con14) - PA3 (con15)
//        E (7SEG/con14) - PA4 (con15)
//        F (7SEG/con14) - PA5 (con15)
//        G (7SEG/con14) - PA6 (con15)
//        . (7SEG/con14) - PA7 (con15)
//
//        0 (7SEG/con14) - PB0 (con16)
//        1 (7SEG/con14) - PB1 (con16)
//        2 (7SEG/con14) - PB2 (con16)
//        3 (7SEG/con14) - PB3 (con16)
//
//******************************************************************************
#include <ST7LITE3.H>
#include <INTRIST7.H>

volatile unsigned char DisplayCounter;
volatile unsigned char Digit0, Digit1, Digit2, Digit3;
// Digits patterns
unsigned char Digits[]= {192, 249, 164, 176, 153, 146, 130, 248, 128, 144, 136, 131, 198, 161, 134, 142};
//-------------------------------------
//
//-------------------------------------
void main(void)
{
PADR = 0xFF;            // Ports initialization	
PBDR = 0x0F;            //
PBOR = 0x0F;
PADDR = 0xFF;           //
PBDDR = 0x0F;           //

LTCSR1 |= (1 << 4); // Enable interupt from LiteTimer RTC1

_rim_(); // Enable interrupts

DisplayCounter = 0;

Digit0=Digits[0];  // write digit '0' pattern to Ditig0
Digit1=Digits[1];  // write digit '1' pattern to Ditig1
Digit2=Digits[2];  // write digit '2' pattern to Ditig2
Digit3=Digits[3];  // write digit '3' pattern to Ditig3

while(1);
}
//-------------------------------------
// LiteTimer RTC1 interrupt handler
//-------------------------------------
void SevenSegmentDisplay(void) interrupt 11
{
DisplayCounter++;
switch(DisplayCounter){
case 1: 
  PBDR |= (1 << 3); 	// DS3 off
  PADR = Digit0; 		// write digit to port
  PBDR &= ~(1 << 0);    // DS0 on
  break;
case 2: 
  PBDR |= (1 << 0);	    // DS0 off
  PADR = Digit1;		// write digit to port
  PBDR &= ~(1 << 1);    // DS1 on
  break;
case 3:
  PBDR |= (1 << 1);	    // DS1 off
  PADR = Digit2;		// write digit to port
  PBDR &= ~(1 << 2);    // DS2 on
break;
case 4: 
  PBDR |= (1 << 2);	    // DS2 off
  PADR = Digit3;		// write digit to port
  PBDR &= ~(1 << 3);    // DS3 on
  DisplayCounter=0;
break;
}
}
//-------------------------------------
// End of file
//-------------------------------------