//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : RC5
// BOARD    : ZL3ST7 (with ST7FLITE39F2B6 in socket U1)
// COMPILER : RKitSTM8 for Ride7
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple infrared RC5 code receiver
//
//    Settings and connections on ZL3ST7:
//        IR (con7) - PB5 (con16)
//
//      if RS232 cable connected:
//        RxD (con7) - PB6 (con16)
//        TxD (con7) - PA7 (con15)
//
//      if UART2USB converter (ZL1USB_A or ZL4USB) connected:
//        RxU (con7) - PB6 (con16)
//        TxU (con7) - PA7 (con15)
//
//******************************************************************************
#include <ST7LITE3.H>

#include "USART.h"
#include "RC5.h"

//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
char str [5];
char RC5Address=0, RC5Command=0;

USART_Init();

USART_PutString("*************************\r");
USART_PutString("**    ZL3ST7 IR RC5    **\r");
USART_PutString("**    www.kamami.com   **\r");
USART_PutString("*************************\r");

USART_PutString("Waiting for RC5...\r");

RC5_Init();

do{
  GetRC5(&RC5Address, &RC5Command);
  USART_PutString("Address (hex): ");
  USART_PutString(Hex(RC5Address, str));
  USART_PutString(" Command (hex): ");
  USART_PutString(Hex(RC5Command, str));

USART_PutChar('\r');
}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
