//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : RTC
// BOARD    : ZL3ST7 (with ST7FLITE39F2B6 in socket U1)
// COMPILER : RKitSTM8 for Ride7
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple I2C communication demo.
//    Read all registers from RTC (U6 - M41T00)
//    and transmit it to PC via UART.
//
//    Settings and connections on ZL3ST7:
//        SCL (U6 RTC/con7) - PB5 (con16)
//        SDA (U6 RTC/con7) - PB3 (con16)
//
//      if RS232 cable connected:
//        RxD (con7) - PB6 (con16)
//        TxD (con7) - PA7 (con15)
//
//      if UART2USB converter (ZL1USB_A or ZL4USB) connected:
//        RxU (con7) - PB6 (con16)
//        TxU (con7) - PA7 (con15)
//
//******************************************************************************
#include "USART.h"
#include "TWI.h"
//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
volatile char i, B1;
char str[5];

USART_Init();
TWI_Init();

USART_PutString("\r");
USART_PutString("*************************\r");
USART_PutString("**     ZL3ST7   RTC    **\r");
USART_PutString("**    www.kamami.com   **\r");
USART_PutString("*************************\r");

// Infinite loop
do{
TWI_Start();                                    // start transmission
TWI_Write(0xD0);                                // write addres of M41T00
TWI_Write(0x00);                                // select first register
TWI_Start();                                    // repeated start
TWI_Write(0xD1);                                // write address for reading data

for(i = 0; i < 8; i++)
  {
  B1 = TWI_Read((i==7)?NACK:ACK);               // 'read data
  USART_PutString("M41T00 byte ");              
  USART_PutChar(i+'0');                         // convert to ASCII char
  USART_PutString(" value ");
  USART_PutString(Hex(B1, str));                // convert to HEX value
  USART_PutChar('\r');
  }
TWI_Stop();                                     // stop transmission
USART_PutString("------------------------------------------\r");

}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
