#include <ST7LITE3.H>
#include <INTRIST7.h>

#define I2C_DR  PBDR
#define I2C_DDR PBDDR
#define I2C_OR  PBOR

#define I2C_SDA (1 << 3)
#define I2C_SCL (1 << 5)
//-------------------------------------
//
//-------------------------------------
void TWI_Delay(void)
{
_nop_();
_nop_();
_nop_();
_nop_();
_nop_();
_nop_();
}
//-------------------------------------
//
//-------------------------------------
void TWI_Init(void)
{
I2C_DDR &= ~(I2C_SDA | I2C_SCL);
I2C_OR  &= ~(I2C_SDA | I2C_SCL);
I2C_DR  &= ~(I2C_SDA | I2C_SCL);
}
//-------------------------------------
//
//-------------------------------------
void TWI_Start(void)
{
I2C_DDR &= ~(I2C_SDA | I2C_SCL);
I2C_DR  &= ~(I2C_SDA | I2C_SCL);
TWI_Delay();
I2C_DDR |= I2C_SDA;
TWI_Delay();
I2C_DDR |= I2C_SCL;
}

void TWI_Stop(void)
{
I2C_DDR &= ~I2C_SCL;
TWI_Delay();
I2C_DDR &= ~I2C_SDA;
}
//-------------------------------------
//
//-------------------------------------
unsigned char TWI_Write(unsigned char val)
{
char cnt = 8;
unsigned char ack=0;
I2C_DDR |= (I2C_SDA | I2C_SCL);
do{
    if(val & 0x80)
        I2C_DDR &= ~I2C_SDA;
    else
        I2C_DDR |= I2C_SDA;
    I2C_DDR &= ~I2C_SCL;
    TWI_Delay();
    I2C_DDR |= I2C_SCL;
    val <<= 1;
    cnt --;
}while(cnt);

I2C_DDR &= ~I2C_SDA;
I2C_DDR &= ~I2C_SCL;
TWI_Delay();
if(I2C_DR & I2C_SDA)
    ack = 1;
else
    ack = 0;
I2C_DDR |= I2C_SDA;
I2C_DDR |= I2C_SCL;
TWI_Delay();
return ack;
}
//-------------------------------------
//
//-------------------------------------
unsigned char TWI_Read(unsigned char ack)
{
unsigned char cnt = 8;
unsigned char val = 0;

I2C_DDR |= (I2C_SDA | I2C_SCL);

I2C_DDR &= ~I2C_SDA;
do{
    val <<= 1;
    TWI_Delay();
    I2C_DDR &= ~I2C_SCL;
    TWI_Delay();
    if(I2C_DR & I2C_SDA)
        val |= 1;
    I2C_DDR |= I2C_SCL;
    cnt --;
}while(cnt);

if(ack)
   I2C_DDR &= ~I2C_SDA;
else
   I2C_DDR |= I2C_SDA; 
I2C_DDR &= ~I2C_SCL;
TWI_Delay();
I2C_DDR |= I2C_SCL;
I2C_DDR |= I2C_SDA;
return val;
}
//-------------------------------------
//
//-------------------------------------