// ***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : TC77
// BOARD    : ZL3ST7 (with ST7FLITE39F2B6 in socket U1)
// COMPILER : RKitSTM8 for Ride7
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple SPI communication demo.
//    Read temperature from temperature sensor (U7 - TC77)
//    and transmit it to PC via UART.
//
//    Settings and connections on ZL3ST7:
//        SIO (U7 TEM/con8) - PB2 (con16)
//        CS  (U7 TEM/con8) - PB0 (con16)
//        SCK (U7 TEM/con8) - PB1 (con16)
//
//      if RS232 cable connected:
//        RxD (con7) - PB6 (con16)
//        TxD (con7) - PA7 (con15)
//
//      if UART2USB converter (ZL1USB_A or ZL4USB) connected:
//        RxU (con7) - PB6 (con16)
//        TxU (con7) - PA7 (con15)
//
//******************************************************************************
#include <ST7LITE3.h>
#include "USART.h"
#include "SPI.h"
//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
char A1,A2;
char str[5];

USART_Init();
SPI_Init();

USART_PutString("\r");
USART_PutString("*************************\r");
USART_PutString("**     ZL3ST7  TC77    **\r");
USART_PutString("**    www.kamami.com   **\r");
USART_PutString("*************************\r");

do{
SPI_CS_DR &= ~SPI_CS; // Enable CS
A1 = SPI_Transmit(0); // read byte
A2 = SPI_Transmit(0); // read byte
SPI_CS_DR |= SPI_CS;  // Disable CS

USART_PutString("TC77 output (hex): ");
USART_PutString(Hex(A1,str)); // convert to hex and send 
USART_PutString(Hex(A2,str)); // convert to hex and send
USART_PutChar('\r');

}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
