//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : UART
// BOARD    : ZL3ST7 (with ST7FLITE39F2B6 in socket U1)
// COMPILER : RKitSTM8 for Ride7
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple UART communication demo.
//
//    Settings and connections on ZL3ST7:
//        JP4 (DISPLAY) - 2-3 (=CHAR)
//
//        D4 (LCD_CHAR/con13) - PA4 (con15)
//        D5 (LCD_CHAR/con13) - PA5 (con15)
//        D6 (LCD_CHAR/con13) - PA6 (con15)
//        D7 (LCD_CHAR/con13) - PA3 (con15)
//        E  (LCD_CHAR/con13) - PA2 (con15)
//        RS (LCD_CHAR/con13) - PA0 (con15)
//        RW (LCD_CHAR/con13) - GND (con15)
//
//      if RS232 cable connected:
//        RxD (con7) - PB6 (con16)
//        TxD (con7) - PA7 (con15)
//
//      if UART2USB converter (ZL1USB_A or ZL4USB) connected:
//        RxU (con7) - PB6 (con16)
//        TxU (con7) - PA7 (con15)
//
//******************************************************************************
#include <ST7LITE3.h>
#include "USART.h"
#include "HD44780.h"
//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
char Message[18];
PADR = 0x80;
PAOR = 0x80;
PADDR = 0x80;

USART_Init();

LCD_Initialize();
LCD_GoTo(0,0);
LCD_WriteText(" ZL3ST7 - UART");
LCD_GoTo(0,1);
LCD_WriteText(" www.kamami.com");

USART_PutChar('\r');
USART_PutString("*************************\r");
USART_PutString("**     ZL3ST7  UART    **\r");
USART_PutString("**    www.kamami.com   **\r");
USART_PutString("*************************\r");

do{
  USART_PutString("->");USART_GetString(Message);
  USART_PutString("<-");USART_PutString(Message);
  LCD_Clear();
  LCD_GoTo(0,0);
  LCD_WriteText("Rx:");
  LCD_GoTo(0,1);
  LCD_WriteText(Message);
}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------